#!/usr/bin/perl

#┌─────────────────────────────────
#│ Midnight Fox Chat : init.cgi - 2011/09/17
#│ Copyright(C) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
my %in = parse_form();

# 認証
check_passwd();

# 処理分岐
admin_mode();

#-----------------------------------------------------------
#  管理モード
#-----------------------------------------------------------
sub admin_mode {
	# 削除実行
	if ($in{del}) {

		my %del;
		foreach ( split(/\0/, $in{del}) ) {
			$del{$_}++;
		}

		my @log;
		open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while(<DAT>) {
			my ($date,$id) = (split(/<>/))[0,6];
			next if (defined($del{$date}));

			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	header("管理モード");
	print <<EOM;
<div class="all">
<form action="$cf{chat_cgi}" method="post">
<input type="hidden" name="id" value="$in{id}">
<input type="hidden" name="pw" value="$in{pw}">
<input type="submit" value="チャットへ移動">
</form>
<br />
<div class="ttl">■管理モード</div>
<p>・ 削除する発言にチェックを入れて削除ボタンを押します。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="id" value="$in{id}">
<input type="hidden" name="pw" value="$in{pw}">
<input type="submit" value="削除する"><br>
EOM

	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while(<IN>) {
		my ($date,$nam,$eml,$com,$col,$ip,$id,$col2) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);

		print qq|<input type="checkbox" name="del" value="$date">\n|;
		print qq|$nam &gt; $com ($date) ($ip) [ $id ]<br>\n|;
	}

	print <<EOM;
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  パスワード認証
#-----------------------------------------------------------
sub check_passwd {
	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		enter_form();

	# パスワード認証
	} elsif ($in{pass} ne $cf{password}) {
		error("認証できません");
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub enter_form {
	header("入室画面");
	print <<EOM;
<div align="center">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="id" value="$in{id}">
<input type="hidden" name="pw" value="$in{pw}">
<table width="380" style="margin-top:50px">
<tr>
	<td height="40" align="center">
		<fieldset><legend>管理パスワード入力</legend><br>
		<input type="password" name="pass" value="" size="20">
		<input type="submit" value=" 認証 "><br><br>
		</fieldset>
	</td>
</tr>
</table>
</form>
<script language="javascript">
<!--
self.document.forms[0].pass.focus();
//-->
</script>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<meta http-equiv="content-script-type" content="text/javascript" />
<meta http-equiv="content-style-type" content="text/css" />
<link href="cmn/admin.css" rel="stylesheet" type="text/css" />
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="./cmn/star.png" alt="star" class="icon">
	<b>Midnight Fox 管理画面</b>
</div>
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub error {
	my $err = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350">
<form>
<input type="button" value="前画面に戻る" onclick="history.back()">
</form>
</div>
</body>
</html>
EOM
	exit;
}

