#!/usr/bin/perl

#┌─────────────────────────────────
#│ Midnight Fox Chat : init.cgi - 2011/09/17
#│ Copyright(C) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Midnight Fox Chat v4.02 - 2021/04/05
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
#
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use Crypt::RC4;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
my %in = parse_form();

# 認証
check_passwd();

# 処理分岐
if ($in{mode} eq 'form') { form(); }
if ($in{mode} eq 'into') { form2(); }
if ($in{mode} eq 'data') { chat_data(); }
if ($in{mode} eq 'out')  { room_out(); }
if ($in{mode} eq 'regist') { regist(); }
if ($in{mode} eq 'border') { border_page(); }
frame();

#-----------------------------------------------------------
#  フォーム : 入室画面
#-----------------------------------------------------------
sub form {
	# クッキー取得
	my ($ck_nam,$ck_eml,$ck_col,$ck_ret,$ck_lin,$ck_col2) = &get_cookie;
	$ck_col = $ck_col ne '' ? $ck_col : 0;
	$ck_ret = $ck_ret ne '' ? $ck_ret : $cf{retime_defo};
	$ck_lin = $ck_lin ne '' ? $ck_lin : $cf{lines_defo};
	$ck_col2 = $ck_col2 ne '' ? $ck_col2 : 0;

	my ($op_retime,$op_lines,$colors,$color2);
	foreach (@{$cf{retime}}) {
		if ($ck_ret == $_) {
			$op_retime .= qq|<option value="$_" selected>$_秒\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_秒\n|;
		}
	}
	foreach (@{$cf{lines}}) {
		if ($ck_lin == $_) {
			$op_lines .= qq|<option value="$_" selected>$_行\n|;
		} else {
			$op_lines .= qq|<option value="$_">$_行\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my ($col,undef) = split(/,/, $cf{colors}->[$_]);
		if ($ck_col == $_) {
			$colors .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$colors .= qq|<input type="radio" name="color" value="$_">|;
		}
		$colors .= qq|<span style="color:$col">■</span>\n|;

		if ($_ == int(@{$cf{colors}}/2)-1) { $colors .= "<br>\n"; }
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	if ($ck_col2 eq "") { $ck_col2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($ck_col2 eq $col3[$_]) {
			$color2 .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color2 .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!admin_cgi!/$cf{admin_cgi}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!login-name!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_lines -->/$op_lines/g;
	$tmpl =~ s/!colors!/$colors/g;
	$tmpl =~ s/!name!/$ck_nam/g;
	$tmpl =~ s/!email!/$ck_eml/g;
	$tmpl =~ s/<!-- op_color2 -->/$color2/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  発言フォーム
#-----------------------------------------------------------
sub form2 {
	my $err;
	if ($in{name} eq '') { $err .= "名前が未入力です<br>"; }
	if ($in{email} && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,}$/) { $err .= "e-mailが不正です<br>"; }
	error($err) if ($err);

	# 入室メッセージ
	&regist('into');

	# クッキー格納
	&set_cookie($in{name},$in{email},$in{color},$in{retime},$in{lines},$in{color2});

	my ($op_retime,$op_lines,$op_colors,$op_faces,$op_colors2);
	foreach (@{$cf{retime}}) {
		if ($in{retime} == $_) {
			$op_retime .= qq|<option value="$_" selected>$_秒\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_秒\n|;
		}
	}
	foreach (@{$cf{lines}}) {
		if ($in{lines} == $_) {
			$op_lines .= qq|<option value="$_" selected>$_行\n|;
		} else {
			$op_lines .= qq|<option value="$_">$_行\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my (undef,$nam) = split(/,/, $cf{colors}->[$_]);
		if ($in{color} == $_) {
			$op_colors .= qq|<option value="$_" selected>$nam\n|;
		} else {
			$op_colors .= qq|<option value="$_">$nam\n|;
		}
	}
	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});

	foreach (0 .. $#col3) {
		if ($in{color2} eq $col3[$_]) {
			$op_colors2 .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$op_colors2 .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}
	foreach (@{$cf{faces}}) {
		$op_faces .= qq|<option value="$_">$_\n|;
	}

	open(IN,"$cf{tmpldir}/form2.html") or &error("open err: form2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 名前をエンコード
	my $enam = url_encode($in{name});

	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!admin_cgi!/$cf{admin_cgi}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!login-name!/$in{id}/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_lines -->/$op_lines/g;
	$tmpl =~ s/<!-- op_colors -->/$op_colors/g;
	$tmpl =~ s/<!-- op_faces -->/$op_faces/g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!email!/$in{email}/g;
	$tmpl =~ s/!enam!/$enam/g;
	$tmpl =~ s/<!-- op_colors2 -->/$op_colors2/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  記事表示部
#-----------------------------------------------------------
sub chat_data {
	my $job = shift;

	if ($in{retime} eq '') { $in{retime} = $cf{retime_defo}; }
	my ($retime,$meta);
	if ($in{retime} == 0) {
		$retime = '手動';
	} else {
		$retime = "$in{retime}秒";
		my $enam = &url_encode($in{name});
		$in{lines} ||= $cf{lines_defo};
		$meta = qq|<meta http-equiv="refresh" content="$in{retime}; url=$cf{chat_cgi}?mode=data&name=$enam&retime=$in{retime}&id=$in{id}&pw=$in{pw}&line=$in{lines}">|;
	}
	$in{lines} ||= $cf{lines_defo};

	# 在室管理
	my ($num,$member) = member($job);

	open(IN,"$cf{tmpldir}/data.html") or &error("open err: data.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!member!/$member/g;
	$tmpl =~ s/!num!/$num/g;
	$tmpl =~ s/!retime!/$retime/g;
	$tmpl =~ s/!lines!/$in{lines}/g;
	$tmpl =~ s/<!-- meta_refresh -->/$meta/;

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		error("テンプレートが不正です");
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	my $i;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		my ($date,$name,$eml,$com,$col,undef,undef,$col2) = split(/<>/);

		my $tmp = $loop;

	if ($name eq 'MASTER') {
		$tmp =~ s/class="says"/class="says02"/g;
		my $sayscol = '#d4d9dc';
		$tmp =~ s/!color2!/$sayscol/g;
		$tmp =~ s|!name!|$name|g;
	}

		$tmp =~ s|!name!|<span style="color:$col">$name</span>|g;
		$tmp =~ s|!comment!|<span style="color:$col">$com</span>|g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!color2!/$col2/g;
		print $tmp;

		# 表示数制限
		last if ($i >= $in{lines});
	}
	close(IN);

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  ログ書き込み
#-----------------------------------------------------------
sub regist {
	my $job = shift;

	# リロードのみ
	chat_data('reload') if (!$job && $in{comment} eq '');

	# 入室時
	my ($name,$color,$color2);
	if ($job eq 'into') {
		$in{comment} = "<b>$in{name}</b>$cf{msg_in}";
		$name  = $cf{master_name};
		$color = $cf{rep_color};
		$color2 = $cf{sayscol};
		$in{email} = '';

	# 退出時
	} elsif ($job eq 'out') {
		$in{comment} = "<b>$in{name}</b>$cf{msg_out}";
		$name  = $cf{master_name};
		$color = $cf{rep_color};
		$color2 = $cf{sayscol};
		$in{email} = '';

	# 発言時
	} else {
		$name = $in{email} ? qq|<a href="mailto:$in{email}">$cf{pointer}</a> <b>$in{name}</b>| : "$cf{pointer} <b>$in{name}</b>";
		($color,undef) = split(/,/, $cf{colors}->[$in{color}]);
		$color2 = $in{color2};
	}

	# 日時取得
	my ($sec,$min,$hour,$mday,$mon,$year) = localtime();
	my $date = sprintf("%04d/%s/%s-%02d:%02d:%02d",$year+1900,$mon+1,$mday,$hour,$min,$sec);

	# ホスト
	my $host = get_host();

	# 顔文字
	$in{comment} .= " $in{face}" if ($in{face});

	# ログを開く
	my ($i,@log);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		$i++;
		push(@log,$_);

		last if ($i >= $cf{maxlog});
	}

	# 追加記事
	unshift (@log,"$date<>$name<>$in{email}<>$in{comment}<>$color<>$host<>$in{id}<>$color2<>\n");

	# 更新
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 発言時は記事画面へ
	chat_data('regist') if (!$job);
}

#-----------------------------------------------------------
#  ボーダーカラー・サンプル
#-----------------------------------------------------------
sub border_page {
	# 時間取得
	my ($date,$time) = get_time2();

	# テンプレート認識
	open(IN,"$cf{tmpldir}/border_color.html") or &error("open err: border_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!chat_title!/$cf{chat_title}/g;
		s/!chat_cgi!/$cf{chat_cgi}/g;
		s/!admin_cgi!/$cf{admin_cgi}/g;
		s/!version!/$cf{version}/g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s/!name!/$col4[$_]/g;
		$tmp =~ s|!color_b!|<div class="chatting"><div class="says" style="border-color:$col3[$_]"><div class="arrow-left02" style="border-color: transparent $col3[$_] transparent transparent;"></div><p>コメント枠色（$date）<br clear="all"></p></div></div>|g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}
#-----------------------------------------------------------
#  時間取得[枠色サンプル用]
#-----------------------------------------------------------
sub get_time2 {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 日時のフォーマット
	my $date = sprintf("%04d/%02d/%02d(%s)",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  退室処理
#-----------------------------------------------------------
sub room_out {
	regist('out');
	member('out');

	open(IN,"$cf{tmpldir}/out.html") or &error("open err: out.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  認証
#-----------------------------------------------------------
sub check_passwd {
	# フォーム入力のチェック
	if ($in{id} eq "" || $in{pw} eq "") {
		enter_form();
	}

	# 認証
	my $flg;
	foreach (@{$cf{passwd}}) {
		my ($id,$pw) = split(/:/);

		if ($in{id} eq $id && $in{pw} eq $pw) {
			$flg++;
			last;
		}
	}
	&error("認証できません") if (!$flg);

	# クッキー記憶
	if ($in{login} == 1) { set_entcook(); }

}

#-----------------------------------------------------------
#  フレーム
#-----------------------------------------------------------
sub frame {
	# フレーム出力
	open(IN,"$cf{tmpldir}/frame.html") or &error("open err: frame.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub enter_form {
	# クッキー取得
	my ($id,$pw) = get_entcook();

	open(IN,"$cf{tmpldir}/enter.html") or &error("open err: enter.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!id!/$id/;
	$tmpl =~ s/!pw!/$pw/;
	if ($id ne '' && $pw ne '') {
		$tmpl =~ s|<input type="checkbox" name="cook"([^<>]+)>|<input type="checkbox" name="cook" checked="checked" $1>|;
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	&footer($tmpl);
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:1.5em;text-align:center;font-family:verdana,helvetica,arial;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">MidnightFoxChat</a> -<br />
++ <a href="http://www.transformsite.com/" target="_top">Edited by HUMMEL</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  在室管理
#-----------------------------------------------------------
sub member {
	my $job = shift;

	# 時間/IP取得
	my $now = time;
	my $addr = $ENV{REMOTE_ADDR};

	my ($i,$member,$flg,@log);
	open(DAT,"+< $cf{memfile}") or &error("open err: $cf{memfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($time,$name,$ip) = split(/<>/);

		# 60秒以上発言のない者は削除
		if ($now - 60 > $time) {
			$flg = 1;
			next;
		}

		if ($addr eq $ip) {
			$flg = 2;

			# 退室者削除
			if ($job eq 'out') {
				next;

			# 時間/名前を更新
			} else {
				$name = $in{name};
				$_ = "$now<>$name<>$addr<>\n";
			}
		}

		# 更新用配列に追加
		push(@log,$_);

		# 参加者表示用文字列を作成
		if ($i % 2) {
			$member .= "$name◇";
			$i++;
		} else {
			$member .= "$name◆";
			$i++;
		}
	}

	# 新規参加者追加
	if (!$flg && $job ne 'out' && $in{name} ne '') {
		$flg = 3;
		push(@log,"$now<>$in{name}<>$addr<>\n");
		$member = $i % 2 ? "$member$in{name}◇" : "$member$in{name}◆";
	}

	# 参加者数
	my $num = @log;

	# ファイル更新
	if ($job || $flg) {
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
	}
	close(DAT);

	return ($num,$member);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_encode {
	my $str = shift;

	$str =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
	$str =~ tr/ /+/;
	return $str;
}

#-----------------------------------------------------------
#  ホスト取得
#-----------------------------------------------------------
sub get_host {
	# IP/ホスト取得
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}
	$host ||= $addr;
	return $host;
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: fox_chat=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/, $cook{fox_chat}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  パスワード取得
#-----------------------------------------------------------
sub get_entcook {
	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}
	$cook{$cf{entcok_id}} =~ s/\W//g;
	
	# バイナリへ戻す
	$cook{$cf{entcok_id}} =~ s/n/\n/g;
	$cook{$cf{entcok_id}} =~ s/([0-9A-Fa-f]{2})/pack('H2',$1)/eg;
	
	# RC4復号
	my $plain = RC4($cf{crypt_key},$cook{$cf{entcok_id}});
	
	return split(/:/,$plain);
}

#-----------------------------------------------------------
#  パスワード記憶
#-----------------------------------------------------------
sub set_entcook {
	if ($in{cook} != 1) {
		print "Set-Cookie: $cf{entcok_id}=; expires=Thu, 1-Jan-1970 00:00:00 GMT;\n";
		
	} else {
		# RC4暗号変換
		my $crypt = RC4($cf{crypt_key},"$in{id}:$in{pw}");

		# バイナリを16進へ
		$crypt =~ s/(.)/unpack('H2',$1)/eg;
		$crypt =~ s/\n/n/g;

		# 60日間有効
		my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
		my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
		my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

		# 時刻フォーマット
		my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
						$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

		print "Set-Cookie: $cf{entcok_id}=$crypt; expires=$gmt\n";
	}
}

