# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ Midnight Fox Chat : init.cgi - 2016/09/22
#│ Copyright(C) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'MIDNIGHT FOX v3.11';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Midnight Fox Chat v4.02 - 2021/04/05
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
#===========================================================
# ■ 基本設定
#===========================================================

# 管理パスワード
$cf{password} = '0123';

# 会員ID/PASS設定
# → IDとPASSをコロンで区切る
$cf{passwd} = [
	"admin:0001",
	"taro:0123",
	"jiro:1234",
	"sabu:5678",
	];

# チャットタイトル
$cf{chat_title} = "MIDNIGHT FOX v3.11";

# チャットプログラム【URLパス】
$cf{chat_cgi}  = './fox.cgi';

# 管理プログラム【URLパス】
$cf{admin_cgi} = './admin.cgi';

# ログファイル【URLパス】
$cf{logfile} = './data/log.cgi';

# 参加者ファイル【URLパス】
$cf{memfile} = './data/mem.cgi';

# テンプレートディレクトリ【URLパス】
$cf{tmpldir} = './tmpl';

# 戻り先【URLパス】
$cf{homepage} = '../../../index.html';

# 最大記事数
$cf{maxlog} = 50;

# 文字色
# → 文字色とその名前をコンマで区切る
$cf{colors} = [
	'#898989,battleship_gray',
	'#000000,black',
	'#008db7,cerulean_blue',
	'#4753a2,ultramarine_ blue',
	'#6c2463,plum',
	'#a688bd,lavender_mauve',
	'#98605e,cocoa_brown',
	'#ea5550,poppy_red',
	'#da81b2,orchid_pink',
	'#e3acae,pink_almond',
	'#e17b34,raw_sienna',
	'#f39800,marigold',
	'#79c06e,spearmint',
	'#387d39,cactus',
	];

# 枠色の設定（半角スペースで区切る）
$cf{colors_b} = '#008db7 #00608d #8d93c8 #4753a2 #e17b34 #ac6b25 #e5a323 #e9bc00 #f39800 #79c06e #417038 #5f6527 #98605e #941f57 #ea5550 #ef857d #47266e #a688bd #6c2463 #da81b2 #f3a68c #e95464 #e3acae #898989 #b4aeb1';

$cf{colors_b2}= 'セルリアンブルー マドンナブルー ウイスタリア ウルトラマリンブルー ローシェンナ ブロンズ パンプキン トパーズ マリーゴールド スペアミント スピナッチグリーン オリーブグリーン ココアブラウン クラレット レッド コーラルレッド ディープロイヤルパープル ラベンダーモーブ プラム オーキッドピンク サーモンピンク ローズ ピンクアーモンド バトルシップグレイ ミスト';

# リロード時間
$cf{retime} = [0,30,40,50,60];

# リロード時間（初期値）
$cf{retime_defo} = 40;

# 表示行数
$cf{lines} = [10,20,30,40,50];

# 表示行数（初期値）
$cf{lines_defo} = 30;

# ポインタの形状（ログ表示部で「名前」の前につく）
$cf{pointer} = "★";

# 入退室時メッセージ
# → 順に、入室時、退室時
$cf{msg_in}  = "さん、いらっしゃい。";
$cf{msg_out} = "さん、さようなら～。";

# 入退室案内の発信者名
$cf{master_name} = "MASTER";

# 入退室案内メッセージの色
$cf{rep_color} = "#808080";
# 入退室コメント枠色
$cf{sayscol} = "#d4d9dc";

# 顔文字
$cf{faces} = ['(＾_＾)', '(＾_＾；)', '(*＾＾*)', '(；_；)', '(ーー；',  '  ｍ（_ _）ｍ', '(・_・)', '(＾＾）/~~', '(＠_＠)', '＼（＾Ｏ＾）／', '(？_？)'];

# 最大受理サイズ（バイト数）
$cf{maxdata} = 102400;

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{entcok_id} = "gateway_ent";

# パスワード保存用暗号キー
# → 適当に変更してください。
$cf{crypt_key} = 'iJT5vxC3';

#===========================================================
# ■ 設定完了
#===========================================================

# 設定内容を返す
sub set_init { 
	return %cf;
}


#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my ($buf,%in);
	if ($ENV{REQUEST_METHOD} eq "POST") {
		&error('受理できません') if ($ENV{CONTENT_LENGTH} > $cf{maxdata});
		read(STDIN, $buf, $ENV{CONTENT_LENGTH});
	} else {
		$buf = $ENV{QUERY_STRING};
	}
	foreach ( split(/&/, $buf) ) {
		my ($key,$val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;

		# 不要コード
		$val =~ s/&/&amp;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&#39;/g;
		$val =~ s/[\r\n]//g;

		$in{$key} .= "\0" if (defined($in{$key}));
		$in{$key} .= $val;
	}
	return %in;
}


1;

